100 REMark Enlarger
110 WINDOW 448,202,32,12 : PAPER 2 : BORDER 1,255 : CLS
120 Enlarge #1,2,2,0,0,20,7,2,'Example 2x2 (unspaced)'
130 Enlarge #1,2,2,1,0,40,7,2,'Example 2x2 (spaced)'
140 Enlarge #1,4,6,0,0,80,7,2,'4x6 (unspaced)'
150 Enlarge #1,4,6,1,0,140,7,2,'4x6 (spaced)'
160 STOP
170 :
180 DEFine PROCedure Enlarge (channel,wide,high,spaced,x,y,ink_colour,paper_colour,str$)
190   LOCal base1,base2,cde1,cde2,nc1,nc2,char,byte
200   base1 = CHAN_L(#channel,42): REMark address of first font
210   base2 = CHAN_L(#channel,46): REMark address of second font
220   cde1  = PEEK(base1)        : REMark lowest valid character 1st font
230   cde2  = PEEK(base2)        : REMark lowest valid character 2nd font
240   nc1   = PEEK(base1+1)      : REMark number of characters-1 1st font
250   nc2   = PEEK(base2+1)      : REMark number of characters-1 2nd font
260   FOR char = 1 TO LEN(str$)
270     cde = CODE(str$(char))
280     SELect ON cde
290       =cde1 TO cde1+nc1: addr = base1+2+(9*(cde-cde1)): REMark font 1
300       =cde2 TO cde2+nc2: addr = base2+2+(9*(cde-cde2)): REMark font 2
310       =REMAINDER       : addr = base2+2 : REMark default character
320     END SELect
330     FOR byte = 0 TO 8
340       row_value = PEEK(addr+byte)
350       across = x + ((6+spaced+spaced) * wide * (char-1))
360       IF spaced = 0 THEN
370         REMark ordinary fonts (bits 7 to 2)
380         FOR bit = 128,64,32,16,8,4     : Plot_Pixel
390       ELSE
400         REMark fonts spaced more widely bits 7 to 0, e.g. "fat" fonts
410         FOR bit = 128,64,32,16,8,4,2,1 : Plot_Pixel
420       END IF
430     END FOR byte
440   END FOR char
450 END DEFine Enlarge
460 :
470 DEFine PROCedure Plot_Pixel
480   IF row_value && bit THEN
490     REMark INK pixels
500     BLOCK #channel,wide,high,across,y+(byte*high),ink_colour
510   ELSE
520     over_state% = CHAN_B%(#channel,66) && 12 : REMark OVER details
530     IF (over_state% && 4) = 0 THEN
540       REMark only plot PAPER pixels if OVER 0
550       OVER #channel,0 : REMark cancel OVER temporarily
560       BLOCK #channel,wide,high,across,y+byte*high,paper_colour : REMark paper
570       REMark restore OVER state for this channel
580       SELect ON over_state% : =4 : OVER #channel,1 : =8 : OVER #channel,-1
590     END IF
600   END IF
610   across = across + wide
620 END DEFine Plot_Pixel
