100 REMark Proportional Spacing printing
110 REMark by Dilwyn Jones Sep. 1997
120 :
130 REMark set up the proportional spacing data for a given channel
140 Setup_Proportional #1
150 :
160 CLS
170 t$ = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 1234567890'
180 PRINT 'Using Normal Print Spacing:'\t$\\ : REMark using normal font
190 :
200 REMark print same string using proportional data
210 Prop_Print #1,'Using Proportional Print Spacing:' : PRINT
220 Prop_Print #1,t$ : PRINT \\ : REMark newlines
230 :
240 STOP
250 :
260 DEFine PROCedure Prop_Print (channel,str$)
270   LOCal char
280   FOR char = 1 TO LEN(str$)
290     REMark change 10 in next line to 20 for CSIZE double height
300     CHAR_INC #channel,prop%(CODE(str$(char))),10
310     PRINT #channel,str$(char);
320   END FOR char
330   CSIZE #0,0,0 : REMark restore standard spacing
340 END DEFine Prop_Print
350 :
360 DEFine PROCedure Setup_Proportional (channel)
370   LOCal addr,char,wide%,lc1%,nc1%,lc2%,nc2%,bit,byte
380   :
390   font1 = CHAN_L(#channel,42) : REMark font 1 address
400   font2 = CHAN_L(#channel,46) : REMark font 2 address
410   :
420   DIM prop%(255) : REMark proportional spacing data
430   lc1% = PEEK(font1)   : REMark lowest character code in font 1
440   nc1% = PEEK(font1+1) : REMark number of characters - 1 in font 1
450   lc2% = PEEK(font2)   : REMark lowest character code in font 2
460   nc2% = PEEK(font2+1) : REMark number of characters - 1 in font 2
470   :
480   FOR char = lc1% TO lc1%+nc1%,lc2%+1 TO lc2%+nc2%
490     IF char <= lc1%+nc1% THEN
500       addr = font1+(9*(char-lc1%))+2
510     ELSE
520       addr = font2+(9*(char-lc2%))+2
530     END IF
540     wide% = 8 : REMark default is full width char in csize 1,0
550     FOR bit = 1,2,4,8,16,32,64,128
560       FOR byte = addr+0 TO addr+8
570         IF (PEEK(byte) && bit) <> 0 THEN
580           prop%(char) = wide%
590           IF prop%(char) < 2 THEN prop%(char) = 2
600           EXIT bit
610         END IF
620       END FOR byte
630       wide% = wide% - 1
640     END FOR bit
650     IF prop%(char) < 2 THEN prop%(char) = 2 : REMark spaces=2 pixels
660   END FOR char
670   :
680   REMark other characters default to lowest character in font1
690   FOR char = 0 TO lc1%-2,lc2%+nc2%+1 TO 255 : prop%(char) = prop%(lc1%)
700 END DEFine Setup_Proportional
